#!/usr/bin/python
# -*- coding: utf-8 -*-

'''Very simple Python library for color and 
    formatting in terminal.'''


class colored:

    def __init__(self, color):
        self.ESC = '\x1b['
        self.END = 'm'
        self.color = color

        self.paint = {
            'black'                  : '0' + self.END,
             0                       : '0' + self.END,
            'red'                    : '1' + self.END,        
             1                       : '1' + self.END,
            'green'                  : '2' + self.END,
             2                       : '2' + self.END,
            'yellow'                 : '3' + self.END,
             3                       : '3' + self.END,
            'blue'                   : '4' + self.END,
             4                       : '4' + self.END,
            'magenta'                : '5' + self.END,
             5                       : '5' + self.END,
            'cyan'                   : '6' + self.END,
             6                       : '6' + self.END,
            'light_gray'             : '7' + self.END,
             7                       : '7' + self.END,
            'dark_gray'              : '8' + self.END,
             8                       : '8' + self.END,
            'light_red'              : '9' + self.END,
             9                       : '9' + self.END,
            'light_green'            : '10' + self.END,
             10                      : '10' + self.END,
            'light_yellow'           : '11' + self.END,
             11                      : '11' + self.END,
            'light_blue'             : '12' + self.END,
             12                      : '12' + self.END,
            'light_magenta'          : '13' + self.END,
             13                      : '13' + self.END,
            'light_cyan'             : '14' + self.END,
             14                      : '14' + self.END,
            'white'                  : '15' + self.END,
             15                      : '15' + self.END,
            'grey_0'                 : '16' + self.END,
             16                      : '16' + self.END,
            'navy_blue'              : '17' + self.END,
             17                      : '17' + self.END,
            'dark_blue'              : '18' + self.END,
             18                      : '18' + self.END,
            'blue_3a'                : '19' + self.END,
             19                      : '19' + self.END,
            'blue_3b'                : '20' + self.END,
             20                      : '20' + self.END,
            'blue_1'                 : '21' + self.END,
             21                      : '21' + self.END,
            'dark_green'             : '22' + self.END,
             22                      : '22' + self.END,
            'deep_sky_blue_4a'       : '23' + self.END,
             23                      : '23' + self.END,
            'deep_sky_blue_4b'       : '24' + self.END,
             24                      : '24' + self.END,
            'deep_sky_blue_4c'       : '25' + self.END,
             25                      : '25' + self.END,
            'dodger_blue_3'          : '26' + self.END,
             26                      : '26' + self.END,
            'dodger_blue_2'          : '27' + self.END,
             27                      : '27' + self.END,
            'green_4'                : '28' + self.END,
             28                      : '28' + self.END,
            'spring_green_4'         : '29' + self.END,
             29                      : '29' + self.END,
            'turquoise_4'            : '30' + self.END,
             30                      : '30' + self.END,
            'deep_sky_blue_3a'       : '31' + self.END,
             31                      : '31' + self.END,
            'deep_sky_blue_3b'       : '32' + self.END,
             32                      : '32' + self.END,
            'dodger_blue_1'          : '33' + self.END,
             33                      : '33' + self.END,
            'green_3a'               : '34' + self.END,
             34                      : '34' + self.END,
            'spring_green_3a'        : '35' + self.END,    
             35                      : '35' + self.END,
            'dark_cyan'              : '36' + self.END,
             36                      : '36' + self.END,
            'light_sea_green'        : '37' + self.END,
             37                      : '37' + self.END,
            'deep_sky_blue_2'        : '38' + self.END,
             38                      : '38' + self.END,
            'deep_sky_blue_1'        : '39' + self.END,
             39                      : '39' + self.END,
            'green_3b'               : '40' + self.END,
             40                      : '40' + self.END,
            'spring_green_3b'        : '41' + self.END,
             41                      : '41' + self.END,
            'spring_green_2a'        : '42' + self.END,
             42                      : '42' + self.END,
            'cyan_3'                 : '43' + self.END,
             43                      : '43' + self.END,
            'dark_turquoise'         : '44' + self.END,
             44                      : '44' + self.END,
            'turquoise_2'            : '45' + self.END,
             45                      : '45' + self.END,
            'green_1'                : '46' + self.END,
             46                      : '46' + self.END,
            'spring_green_2b'        : '47' + self.END,
             47                      : '47' + self.END,
            'spring_green_1'         : '48' + self.END,
             48                      : '48' + self.END,
            'medium_spring_green'    : '49' + self.END,
             49                      : '49' + self.END,
            'cyan_2'                 : '50' + self.END,
             50                      : '50' + self.END,
            'cyan_1'                 : '51' + self.END,
             51                      : '51' + self.END,
            'dark_red_1'             : '52' + self.END,
             52                      : '52' + self.END,
            'deep_pink_4a'           : '53' + self.END,
             53                      : '53' + self.END,
            'purple_4a'              : '54' + self.END,
             54                      : '54' + self.END,
            'purple_4b'              : '55' + self.END,
             55                      : '55' + self.END,
            'purple_3'               : '56' + self.END,    
             56                      : '56' + self.END,
            'blue_violet'            : '57' + self.END,
             57                      : '57' + self.END,
            'orange_4a'              : '58' + self.END,
             58                      : '58' + self.END,
            'grey_37'                : '59' + self.END,
             59                      : '59' + self.END,
            'medium_purple_4'        : '60' + self.END,
             60                      : '60' + self.END,
            'slate_blue_3a'          : '61' + self.END,
             61                      : '61' + self.END,
            'slate_blue_3b'          : '62' + self.END,
             62                      : '62' + self.END,
            'royal_blue_1'           : '63' + self.END,
             63                      : '63' + self.END,
            'chartreuse_4'           : '64' + self.END,
             64                      : '64' + self.END,
            'dark_sea_green_4a'      : '65' + self.END,
             65                      : '65' + self.END,
            'pale_turquoise_4'       : '66' + self.END,
             66                      : '66' + self.END,
            'steel_blue'             : '67' + self.END,
             67                      : '67' + self.END,
            'steel_blue_3'           : '68' + self.END,
             68                      : '68' + self.END,
            'cornflower_blue'        : '69' + self.END,
             69                      : '69' + self.END,
            'chartreuse_3a'          : '70' + self.END,
             70                      : '70' + self.END,
            'dark_sea_green_4b'      : '71' + self.END,
             71                      : '71' + self.END,  
            'cadet_blue_2'           : '72' + self.END,
             72                      : '72' + self.END,
            'cadet_blue_1'           : '73' + self.END,
             73                      : '73' + self.END,
            'sky_blue_3'             : '74' + self.END,
             74                      : '74' + self.END,
            'steel_blue_1a'          : '75' + self.END,
             75                      : '75' + self.END,
            'chartreuse_3b'          : '76' + self.END,
             76                      : '76' + self.END,
            'pale_green_3a'          : '77' + self.END,
             77                      : '77' + self.END,
            'sea_green_3'            : '78' + self.END,
             78                      : '78' + self.END,
            'aquamarine_3'           : '79' + self.END,
             79                      : '79' + self.END,
            'medium_turquoise'       : '80' + self.END,
             80                      : '80' + self.END,
            'steel_blue_1b'          : '81' + self.END,
             81                      : '81' + self.END,
            'chartreuse_2a'          : '82' + self.END,
             82                      : '82' + self.END,
            'sea_green_2'            : '83' + self.END,
             83                      : '83' + self.END,
            'sea_green_1a'           : '84' + self.END,
             84                      : '84' + self.END,
            'sea_green_1b'           : '85' + self.END,        
             85                      : '85' + self.END,
            'aquamarine_1a'          : '86' + self.END,
             86                      : '86' + self.END,
            'dark_slate_gray_2'      : '87' + self.END,
             87                      : '87' + self.END,
            'dark_red_2'             : '88' + self.END,
             88                      : '88' + self.END,
            'deep_pink_4b'           : '89' + self.END,
             89                      : '89' + self.END,
            'dark_magenta_1'         : '90' + self.END,
             90                      : '90' + self.END,
            'dark_magenta_2'         : '91' + self.END,
             91                      : '91' + self.END,
            'dark_violet_1a'         : '92' + self.END,
             92                      : '92' + self.END,
            'purple_1a'              : '93' + self.END,
             93                      : '93' + self.END,
            'orange_4b'              : '94' + self.END,
             94                      : '94' + self.END,
            'light_pink_4'           : '95' + self.END,
             95                      : '95' + self.END,
            'plum_4'                 : '96' + self.END,
             96                      : '96' + self.END,
            'medium_purple_3a'       : '97' + self.END,
             97                      : '97' + self.END,
            'medium_purple_3b'       : '98' + self.END,
             98                      : '98' + self.END,
            'slate_blue_1'           : '99' + self.END,
             99                      : '99' + self.END,
            'yellow_4a'              : '100' + self.END,
             100                     : '100' + self.END,
            'wheat_4'                : '101' + self.END,
             101                     : '101' + self.END,
            'grey_53'                : '102' + self.END,
             102                     : '102' + self.END,
            'light_slate_grey'       : '103' + self.END,
             103                     : '103' + self.END,
            'medium_purple'          : '104' + self.END,
             104                     : '104' + self.END,
            'light_slate_blue'       : '105' + self.END,
             105                     : '105' + self.END,
            'yellow_4b'              : '106' + self.END,
             106                     : '106' + self.END,
            'dark_olive_green_3a'    : '107' + self.END,
             107                     : '107' + self.END,
            'dark_green_sea'         : '108' + self.END,
             108                     : '108' + self.END,
            'light_sky_blue_3a'      : '109' + self.END,
             109                     : '109' + self.END,
            'light_sky_blue_3b'      : '110' + self.END,
             110                     : '110' + self.END,
            'sky_blue_2'             : '111' + self.END,
             111                     : '111' + self.END,
            'chartreuse_2b'          : '112' + self.END,
             112                     : '112' + self.END,
            'dark_olive_green_3b'    : '113' + self.END,
             113                     : '113' + self.END,
            'pale_green_3b'          : '114' + self.END,
             114                     : '114' + self.END,
            'dark_sea_green_3a'      : '115' + self.END,
             115                     : '115' + self.END,
            'dark_slate_gray_3'      : '116' + self.END,
             116                     : '116' + self.END,
            'sky_blue_1'             : '117' + self.END,
             117                     : '117' + self.END,
            'chartreuse_1'           : '118' + self.END,
             118                     : '118' + self.END,
            'light_green_2'          : '119' + self.END,
             119                     : '119' + self.END,
            'light_green_3'          : '120' + self.END,
             120                     : '120' + self.END,
            'pale_green_1a'          : '121' + self.END,
             121                     : '121' + self.END,
            'aquamarine_1b'          : '122' + self.END,
             122                     : '122' + self.END,
            'dark_slate_gray_1'      : '123' + self.END,
             123                     : '123' + self.END,
            'red_3a'                 : '124' + self.END,
             124                     : '124' + self.END,
            'deep_pink_4c'           : '125' + self.END,
             125                     : '125' + self.END,   
            'medium_violet_red'      : '126' + self.END,
             126                     : '126' + self.END,
            'magenta_3a'             : '127' + self.END,
             127                     : '127' + self.END,
            'dark_violet_1b'         : '128' + self.END,
             128                     : '128' + self.END,
            'purple_1b'              : '129' + self.END,
             129                     : '129' + self.END,
            'dark_orange_3a'         : '130' + self.END,
             130                     : '130' + self.END,
            'indian_red_1a'          : '131' + self.END,
             131                     : '131' + self.END,
            'hot_pink_3a'            : '132' + self.END,
             132                     : '132' + self.END,
            'medium_orchid_3'        : '133' + self.END,
             133                     : '133' + self.END,
            'medium_orchid'          : '134' + self.END,
             134                     : '134' + self.END,
            'medium_purple_2a'       : '135' + self.END,
             135                     : '135' + self.END,
            'dark_goldenrod'         : '136' + self.END,
             136                     : '136' + self.END,
            'light_salmon_3a'        : '137' + self.END,
             137                     : '137' + self.END,
            'rosy_brown'             : '138' + self.END,
             138                     : '138' + self.END,
            'grey_63'                : '139' + self.END,
             139                     : '139' + self.END,
            'medium_purple_2b'       : '140' + self.END,
             140                     : '140' + self.END,
            'medium_purple_1'        : '141' + self.END,
             141                     : '141' + self.END,
            'gold_3a'                : '142' + self.END,
             142                     : '142' + self.END,
            'dark_khaki'             : '143' + self.END,
             143                     : '143' + self.END,
            'navajo_white_3'         : '144' + self.END,
             144                     : '144' + self.END,
            'grey_69'                : '145' + self.END,
             145                     : '145' + self.END,
            'light_steel_blue_3'     : '146' + self.END,
             146                     : '146' + self.END,
            'light_steel_blue'       : '147' + self.END,
             147                     : '147' + self.END,
            'yellow_3a'              : '148' + self.END,
             148                     : '148' + self.END,
            'dark_olive_green_3'     : '149' + self.END,
             149                     : '149' + self.END,
            'dark_sea_green_3b'      : '150' + self.END,
             150                     : '150' + self.END,                   
            'dark_sea_green_2'       : '151' + self.END,
             151                     : '151' + self.END,
            'light_cyan_3'           : '152' + self.END,
             152                     : '152' + self.END,
            'light_sky_blue_1'       : '153' + self.END,
             153                     : '153' + self.END,
            'green_yellow'           : '154' + self.END,
             154                     : '154' + self.END,
            'dark_olive_green_2'     : '155' + self.END,
             155                     : '155' + self.END,
            'pale_green_1b'          : '156' + self.END,
             156                     : '156' + self.END,
            'dark_sea_sreen_2'       : '157' + self.END,
             157                     : '157' + self.END,
            'dark_sea_sreen_1'       : '158' + self.END,
             158                     : '158' + self.END,
            'pale_turquoise_1'       : '159' + self.END,
             159                     : '159' + self.END,
            'red_3a'                 : '160' + self.END,
             160                     : '160' + self.END,
            'deep_pink_3a'           : '161' + self.END,
             161                     : '161' + self.END,
            'deep_pink_3b'           : '162' + self.END,
             162                     : '162' + self.END,
            'magenta_3b'             : '162' + self.END,
             163                     : '163' + self.END,
            'magenta_3c'             : '164' + self.END,
             164                     : '164' + self.END,
            'magenta_2a'             : '165' + self.END,
             165                     : '165' + self.END,
            'dark_orange_3b'         : '166' + self.END,
             166                     : '166' + self.END,
            'indian_red_1b'          : '167' + self.END,
             167                     : '167' + self.END,
            'hot_pink_3b'            : '168' + self.END,
             168                     : '168' + self.END,  
            'hot_pink_2'             : '169' + self.END,
             169                     : '169' + self.END,
            'orchid'                 : '170' + self.END,
             170                     : '170' + self.END,
            'medium_orchid_1a'       : '171' + self.END,
             171                     : '171' + self.END,
            'orange_3'               : '172' + self.END,
             172                     : '172' + self.END,
            'light_salmon_3b'        : '173' + self.END,
             173                     : '173' + self.END,
            'light_Pink_3'           : '174' + self.END,
             174                     : '174' + self.END,
            'pink_3'                 : '175' + self.END,
             175                     : '175' + self.END,
            'plum_3'                 : '176' + self.END,
             176                     : '176' + self.END,
            'violet'                 : '177' + self.END,
             177                     : '177' + self.END,
            'gold_3b'                : '178' + self.END,
             178                     : '178' + self.END,  
            'light_Goldenrod_3'      : '179' + self.END,
             179                     : '179' + self.END,
            'tan'                    : '180' + self.END,
             180                     : '180' + self.END,
            'misty_rose_3'           : '181' + self.END,
             181                     : '181' + self.END,
            'thistle_3'              : '182' + self.END,
             182                     : '182' + self.END,
            'plum_2'                 : '183' + self.END,
             183                     : '183' + self.END,
            'yellow_3b'              : '184' + self.END,
             184                     : '184' + self.END,
            'khaki_3'                : '185' + self.END,
             185                     : '185' + self.END,
            'light_goldenrod_2a'     : '186' + self.END,
             186                     : '186' + self.END,
            'light_yellow_3'         : '187' + self.END,
             187                     : '187' + self.END,
            'grey_84'                : '188' + self.END,
             188                     : '188' + self.END,
            'light_steel_blue_1'     : '189' + self.END,
             189                     : '189' + self.END,
            'yellow_2'               : '190' + self.END,
             190                     : '190' + self.END,
            'dark_olive_green_1a'    : '191' + self.END,
             191                     : '191' + self.END,
            'dark_olive_green_1b'    : '192' + self.END,
             192                     : '192' + self.END,
            'dark_sea_green_1'       : '193' + self.END,
             193                     : '193' + self.END,
            'honeydew_2'             : '194' + self.END,
             194                     : '194' + self.END,
            'light_cyan_1'           : '195' + self.END,
             195                     : '195' + self.END,
            'red_1'                  : '196' + self.END,
             196                     : '196' + self.END,
            'deep_pink_2'            : '197' + self.END,
             197                     : '199' + self.END,
            'deep_pink_1a'           : '198' + self.END,
             198                     : '198' + self.END,
            'deep_pink_1b'           : '199' + self.END,
             199                     : '199' + self.END,
            'magenta_2b'             : '200' + self.END,
             200                     : '200' + self.END,
            'magenta_1'              : '201' + self.END,
             201                     : '201' + self.END,
            'orange_red_1'           : '202' + self.END,
             202                     : '202' + self.END,
            'indian_red_1c'          : '203' + self.END,
             203                     : '203' + self.END,
            'indian_red_1d'          : '204' + self.END,
             204                     : '204' + self.END,
            'hot_pink_1a'            : '205' + self.END,
             205                     : '205' + self.END,
            'hot_pink_1b'            : '206' + self.END,
             206                     : '206' + self.END,
            'medium_orchid_1b'       : '207' + self.END,
             207                     : '207' + self.END,
            'dark_orange'            : '208' + self.END,
             208                     : '208' + self.END,
            'salmon_1'               : '209' + self.END,
             209                     : '209' + self.END,
            'light_coral'            : '210' + self.END,
             210                     : '210' + self.END,
            'pale_violet_red_1'      : '211' + self.END,
             211                     : '211' + self.END,
            'orchid_2'               : '212' + self.END,
             212                     : '212' + self.END,
            'orchid_1'               : '213' + self.END,
             213                     : '213' + self.END,
            'orange_1'               : '214' + self.END,
             214                     : '214' + self.END,
            'sandy_brown'            : '215' + self.END,
             215                     : '215' + self.END,
            'light_salmon_1'         : '216' + self.END,
             216                     : '216' + self.END,
            'light_pink_1'           : '217' + self.END,
             217                     : '217' + self.END,
            'pink_1'                 : '218' + self.END,
             218                     : '218' + self.END,
            'plum_1'                 : '219' + self.END,
             219                     : '219' + self.END,
            'gold_1'                 : '220' + self.END,
             220                     : '220' + self.END,
            'light_goldenrod_2b'     : '221' + self.END,
             221                     : '221' + self.END,
            'light_goldenrod_2c'     : '222' + self.END,
             222                     : '222' + self.END,
            'navajo_white_1'         : '223' + self.END,
             223                     : '223' + self.END,
            'misty_rose1'            : '224' + self.END,
             224                     : '224' + self.END,
            'thistle_1'              : '225' + self.END,
             225                     : '225' + self.END,
            'yellow_1'               : '226' + self.END,
             226                     : '226' + self.END,
            'light_goldenrod_1'      : '227' + self.END,
             227                     : '227' + self.END,
            'khaki_1'                : '228' + self.END,
             228                     : '228' + self.END,
            'wheat_1'                : '229' + self.END,
             229                     : '229' + self.END,
            'cornsilk_1'             : '230' + self.END,
             230                     : '230' + self.END,
            'grey_100'               : '231' + self.END,
             231                     : '231' + self.END,
            'grey_3'                 : '232' + self.END,
             232                     : '232' + self.END,
            'grey_7'                 : '233' + self.END,
             233                     : '233' + self.END,
            'grey_11'                : '234' + self.END,
             234                     : '234' + self.END,
            'grey_15'                : '235' + self.END,
             235                     : '235' + self.END,
            'grey_19'                : '236' + self.END,
             236                     : '236' + self.END,
            'grey_23'                : '237' + self.END,
             237                     : '237' + self.END,
            'grey_27'                : '238' + self.END,
             238                     : '238' + self.END,
            'grey_30'                : '239' + self.END,
             239                     : '239' + self.END,
            'grey_35'                : '240' + self.END,
             240                     : '240' + self.END,
            'grey_39'                : '241' + self.END,
             241                     : '241' + self.END,
            'grey_42'                : '242' + self.END,
             242                     : '242' + self.END,
            'grey_46'                : '243' + self.END,
             243                     : '243' + self.END,
            'grey_50'                : '244' + self.END,
             244                     : '244' + self.END,
            'grey_54'                : '245' + self.END,
             245                     : '245' + self.END,
            'grey_58'                : '246' + self.END,
             246                     : '246' + self.END,
            'grey_62'                : '247' + self.END,
             247                     : '247' + self.END,
            'grey_66'                : '248' + self.END,
             248                     : '248' + self.END,
            'grey_70'                : '249' + self.END,
             249                     : '249' + self.END,
            'grey_74'                : '250' + self.END,
             250                     : '250' + self.END,
            'grey_78'                : '251' + self.END,
             251                     : '251' + self.END,
            'grey_82'                : '252' + self.END,
             252                     : '252' + self.END,
            'grey_85'                : '253' + self.END,
             253                     : '253' + self.END,
            'grey_89'                : '254' + self.END,
             254                     : '254' + self.END,
            'grey_93'                : '255' + self.END,
             255                     : '255' + self.END,
            'default'                :  self.END,
             256                     :  self.END
        }       



    def attribute(self):
        '''Set or reset attributes'''

        paint = {
            'bold'           : self.ESC + '1' + self.END,
             1               : self.ESC + '1' + self.END,
            'dim'            : self.ESC + '2' + self.END,
             2               : self.ESC + '2' + self.END,
            'underlined'     : self.ESC + '4' + self.END,
             4               : self.ESC + '4' + self.END,
            'blink'          : self.ESC + '5' + self.END,
             5               : self.ESC + '5' + self.END,
            'reverse'        : self.ESC + '7' + self.END,
             7               : self.ESC + '7' + self.END,
            'hidden'         : self.ESC + '8' + self.END,
             8               : self.ESC + '8' + self.END,
            'reset'          : self.ESC + '0' + self.END,
             0               : self.ESC + '0' + self.END,
            'res_bold'       : self.ESC + '21' + self.END,
             21              : self.ESC + '21' + self.END,
            'res_dim'        : self.ESC + '22' + self.END,
             22              : self.ESC + '22' + self.END,
            'res_underlined' : self.ESC + '24' + self.END,
             24              : self.ESC + '24' + self.END,
            'res_blink'      : self.ESC + '25' + self.END,
             25              : self.ESC + '25' + self.END,
            'res_reverse'    : self.ESC + '27' + self.END,
             27              : self.ESC + '27' + self.END,
            'res_hidden'     : self.ESC + '28' + self.END,
             28              : self.ESC + '28' + self.END,
        }

        return paint[self.color]



    def foreground(self):
        '''Print 256 foreground colors'''

        if self.color == 256 or self.color == 'default':
            code = self.ESC + '39'
        else:
            code = self.ESC + '38;5;'

        return code + self.paint[self.color]



    def background(self):
        '''Print 256 background colors'''

        if self.color == 256 or self.color == 'default':
            code = self.ESC + '49'
        else:
            code = self.ESC + '48;5;'
    
        return code + self.paint[self.color]
 


def attr(color):
    '''alias for colored().attribute()'''

    return colored(color).attribute()


def fg(color):
    '''alias for colored().foreground()'''

    return colored(color).foreground()


def bg(color):
    '''alias for colored().background()'''

    return colored(color).background()

